/* XNibbles - A simple X11 snake game
   Copyright (C) 1998 Sean MacIsaac and Ian Peters
  
   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2 of the License, or
   (at your option) any later version.
  
   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY of FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.
  
   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software Foundation,
   Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
  
   Specific questions about this program can be addressed to the authors,
   Sean Macisaac (sjm@acm.org), and Ian Peters (ipeters@acm.org). */

const int WIDTH = 920;
const int HEIGHT = 690;

#define BWIDTH (int)92
#define BHEIGHT (int)66
#define SOUNDS 11
#define NUMCHANNELS 8
#define MAXNAMELENGTH 10
#define MAXBONI 300
#define NUMBONUS 7
#define MELTSIZE 8
#define FLASHCOUNT 8

#define NOCOLORS 1
#define makePixmap(a, b) if (XpmCreatePixmapFromData(display, win, a , b , NULL, &myXpmAttributes)) \
                           error(NOCOLORS);

const int LEDGE = 0;
const int REDGE = 101;
const int TEDGE = 0;
const int BEDGE = 72;

#include <X11/Xlib.h>
#include <X11/Xutil.h>
#include <X11/Xos.h>
#include <X11/Xatom.h>
#include <X11/xpm.h>
#include <stdio.h>
#include <stdlib.h>
#include <sys/time.h>
#include <unistd.h>
#include <math.h>
#include <string.h>
#include <ctype.h>
extern char *worm_xpm[];
extern char *deadWorm_xpm[];
extern char *wall1_xpm[];
extern char *wall2_xpm[];
extern char *wall3_xpm[];
extern char *wall4_xpm[];
extern char *wall5_xpm[];
extern char *wall6_xpm[];
extern char *wall7_xpm[];
extern char *wall8_xpm[];
extern char *wall9_xpm[];
extern char *wall10_xpm[];
extern char *wall11_xpm[];
extern char *target_xpm[];
extern char *warp_xpm[];
extern char *half_xpm[];
extern char *remains_xpm[];
extern char *double_xpm[];
extern char *life_xpm[];
extern char *reverse_xpm[];
extern char *a_xpm[];
extern char *b_xpm[];
extern char *c_xpm[];
extern char *d_xpm[];
extern char *e_xpm[];
extern char *f_xpm[];
extern char *g_xpm[];
extern char *h_xpm[];
extern char *i_xpm[];
extern char *j_xpm[];
extern char *k_xpm[];
extern char *l_xpm[];
extern char *m_xpm[];
extern char *n_xpm[];
extern char *o_xpm[];
extern char *p_xpm[];
extern char *q_xpm[];
extern char *r_xpm[];
extern char *s_xpm[];
extern char *t_xpm[];
extern char *u_xpm[];
extern char *v_xpm[];
extern char *w_xpm[];
extern char *x_xpm[];
extern char *y_xpm[];
extern char *z_xpm[];
extern char *num0_xpm[];
extern char *num1_xpm[];
extern char *num2_xpm[];
extern char *num3_xpm[];
extern char *num4_xpm[];
extern char *num5_xpm[];
extern char *num6_xpm[];
extern char *num7_xpm[];
extern char *num8_xpm[];
extern char *num9_xpm[];
extern char *unused_xpm[];
extern char *bar_xpm[];
extern char *logo_xpm[];
extern char *paused_xpm[];
extern char *level1_xnl[];
extern char *level2_xnl[];
extern char *level3_xnl[];
extern char *level4_xnl[];
extern char *level5_xnl[];
extern char *level6_xnl[];
extern char *level7_xnl[];
extern char *level8_xnl[];
extern char *level9_xnl[];
extern char *level10_xnl[];
extern char *level11_xnl[];
extern char *level12_xnl[];
#include "ticker.h"
#include "timer.h"
#include "statusBar.h"
#ifdef __SOUND__
#include "sound.h"
#endif
#ifdef __JOYSTICK__
#include "joystick.h"
#endif
#include "counter.h"
#include "bonus.h"
#include "boni.h"
#include "bodyPart.h"
#include "worm.h"
#include "walls.h"
#include "levels.h"
#include "people.h"
#include "deadWorm.h"
